﻿@page "/admin"
@using VacationSchedule.Core.Models.DB;
@inject HttpClient Http

<PageTitle>Учетные записи</PageTitle>

<h1>Управление учетными записями</h1>

@if (users == null)
{
    <p><em>Loading...</em></p>
}
else
{
    <table class="table">
        <thead>
            <tr>
                <th>Логин</th>
                <th>Ф.И.О</th>
                <th>Роль</th>
                <th>Действия</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var user in users)
            {
                <tr>
                    <td>@user.Login</td>
                    <td>@user.LastName @user.FirstName @user.PatronymicName</td>
                    <td>
                        <select class="form-control selectpicker" @bind="@user.RoleId">
                            <option>--select--</option>
                            @foreach (var item in roles)
                            {
                                <option value="@item.Id">@item.RoleName</option>
                            }
                        </select>
                    </td>
                    <td>
                        <button class="btn btn-primary" @onclick="@(e => SaveUser(@user))">Save</button>
                    </td>
                </tr>
            }
        </tbody>
    </table>
}

@code {
    private User[] users;
    private Role[] roles;

    protected override async Task OnInitializedAsync()
    {
        roles = await Http.GetFromJsonAsync<Role[]>($"api/Role");
        users = await Http.GetFromJsonAsync<User[]>($"api/User");
    }

    private async Task SaveUser(User user)
    {
        await Http.PutAsJsonAsync<User>($"api/User/{user.Id}", user);
    }
}
